# Config Grub/WarX-16 - linuxentry.cfg
# Copyright (C) 2018 WarX-16 <contact@warx-16.org>.
# https://www.warx-16.org
#
# Config Grub/WarX-16 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Config Grub/WarX-16 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Config Grub/WarX-16.  If not, see <https://www.gnu.org/licenses/>.
#
# Certain part of Config Grub/WarX-16 was inspired by Super Grub Disk
# ( Adrian Gibanel Lopez - Jordan Uggla - https://www.supergrubdisk.org/ )


#~ set part="${part}"
set root="${part}"

#~ set tscheme="${tscheme}"
#~ set fstype="${fstype}"
#~ set uuid="${uuid}"

set os_name="${os_find}"
#~ set os_ico="${os_ico}"
set kernel="${ls_item}"


if [ -f "${kernel}" ]; then
	regexp -s vers '/boot/vmlinuz-(.*)' "${ls_item}"
	regexp -s vers '/boot/linux-(.*)' "${ls_item}"
	regexp -s vers '/boot/kernel-genkernel-(.*)' "${ls_item}"

	for rd in "initrd-${vers}.img" "initrd.img-${vers}" "initrd-${vers}" \
				"initramfs-genkernel-${vers}" "initramfs-${vers}.img" \
				; do
		if [ -f "/boot/${rd}" ]; then
			set ramdisk="/boot/${rd}"
			break
		fi
	done; unset rd

	for sh in 'bash' 'ksh' 'zsh' 'csh' \
				'tcsh' 'fish' 'ash' 'sh' \
				; do
		if [ -f "/bin/${sh}" ]; then
			set shell="${sh}"
			break
		fi
	done; unset sh

	submenu --class="${os_ico}" "(${part}:${tscheme}:${fstype}) [${os_name} ${vers}]" \
			"${part}" "${tscheme}" "${fstype}" "${uuid}" \
			"${os_name}" "${os_ico}" "${kernel}" "${ramdisk}" "${vers}" "${shell}" {
	set part="$2"
	set tscheme="$3"
	set fstype="$4"
	set uuid="$5"
	set os_name="$6"
	set os_ico="$7"
	set kernel="$8"
	set ramdisk="$9"
	set vers="$10"
	set shell="$11"

	retour "${checkpoint}"

	menuentry --class="${os_ico}" "(${part}:${tscheme}:${fstype}) [${os_name} ${vers}]" "${part}" "${uuid}" "${kernel}" "${ramdisk}" {
	set root="$2"
	set uuid="$3"
	set kernel="$4"
	set ramdisk="$5"

	echo $"Loading"" ${kernel} "$"in normal mode""..."
	linux "${kernel}" root="UUID=${uuid}" ro
	if [ -n "${ramdisk}" ]; then
		echo $"Loading"" ${ramdisk}""..."
		initrd "${ramdisk}"
	fi
	}

	menuentry --class="${os_ico}" "(${part}:${tscheme}:${fstype}) [${os_name} ${vers}] ("$"single-user"")" "${part}" "${uuid}" "${kernel}" "${ramdisk}" {
	set root="$2"
	set uuid="$3"
	set kernel="$4"
	set ramdisk="$5"

	echo $"Loading"" ${kernel} "$"in single-user mode""..."
	linux "${kernel}" root="UUID=${uuid}" ro single
	if [ -n "${ramdisk}" ]; then
		echo $"Loading"" ${ramdisk}""..."
		initrd "${ramdisk}"
	fi
	}

	if [ -n "${shell}" ]; then
	menuentry --class="${os_ico}" "(${part}:${tscheme}:${fstype}) [${os_name} ${vers}] (${shell}: "$"root access"")" "${part}" "${uuid}" "${kernel}" "${ramdisk}" "${shell}" {
	set root="$2"
	set uuid="$3"
	set kernel="$4"
	set ramdisk="$5"
	set shell="$6"

	echo $"Loading"" ${kernel} "$"in root access mode with"" ${shell}..."
	linux "${kernel}" root="UUID=${uuid}" rw S init="/bin/${shell}"
	if [ -n "${ramdisk}" ]; then
		echo $"Loading"" ${ramdisk}""..."
		initrd "${ramdisk}"
	fi
	}
	fi

	}
fi

set root="${root_saved}"
